Index: src/org/mifos/application/reports/business/ReportParameterForm.java
===================================================================
--- src/org/mifos/application/reports/business/ReportParameterForm.java	(revision 0)
+++ src/org/mifos/application/reports/business/ReportParameterForm.java	(revision 0)
@@ -0,0 +1,10 @@
+package org.mifos.application.reports.business;
+
+import org.mifos.application.reports.business.validator.Errors;
+import org.mifos.framework.servlet.ModifiableParameterServletRequest;
+
+public interface ReportParameterForm {
+	public void validate(Errors errors);
+
+	public void removeRequestParameters(ModifiableParameterServletRequest modifiedRequest, Errors errors);
+}
Index: src/org/mifos/application/reports/business/CollectionSheetReportParameters.java
===================================================================
--- src/org/mifos/application/reports/business/CollectionSheetReportParameters.java	(revision 0)
+++ src/org/mifos/application/reports/business/CollectionSheetReportParameters.java	(revision 0)
@@ -0,0 +1,134 @@
+package org.mifos.application.reports.business;
+
+import static org.mifos.application.reports.ui.SelectionItem.NA_CENTER_SELECTION_ITEM;
+import static org.mifos.application.reports.ui.SelectionItem.NA_LOAN_OFFICER_SELECTION_ITEM;
+import static org.mifos.application.reports.ui.SelectionItem.SELECT_BRANCH_OFFICE_SELECTION_ITEM;
+import static org.mifos.application.reports.ui.SelectionItem.SELECT_CENTER_SELECTION_ITEM;
+import static org.mifos.application.reports.ui.SelectionItem.SELECT_LOAN_OFFICER_SELECTION_ITEM;
+import static org.mifos.application.reports.util.helpers.CollectionSheetReportConstants.BRANCH_ID_PARAM;
+import static org.mifos.application.reports.util.helpers.CollectionSheetReportConstants.CENTER_ID_INVALID_MSG;
+import static org.mifos.application.reports.util.helpers.CollectionSheetReportConstants.CENTER_ID_PARAM;
+import static org.mifos.application.reports.util.helpers.CollectionSheetReportConstants.LOAN_OFFICER_ID_INVALID_MSG;
+import static org.mifos.application.reports.util.helpers.CollectionSheetReportConstants.LOAN_OFFICER_ID_PARAM;
+import static org.mifos.application.reports.util.helpers.CollectionSheetReportConstants.MEETING_DATE_INVALID_MSG;
+import static org.mifos.application.reports.util.helpers.CollectionSheetReportConstants.MEETING_DATE_PARAM;
+import static org.mifos.application.reports.util.helpers.CollectionSheetReportConstants.REPORT_PARAMS_ARRAY;
+
+import java.text.ParseException;
+import java.text.SimpleDateFormat;
+import java.util.Date;
+
+import javax.servlet.http.HttpServletRequest;
+
+import org.mifos.application.reports.business.validator.Errors;
+import org.mifos.application.reports.ui.DateSelectionItem;
+import org.mifos.framework.servlet.ModifiableParameterServletRequest;
+import org.mifos.framework.util.helpers.NumberUtils;
+
+public class CollectionSheetReportParameters implements ReportParameterForm {
+
+	public static final SimpleDateFormat REPORT_DATE_PARAM_FORMAT = new SimpleDateFormat(
+			"MM/dd/yyyy hh:mm:ss a");
+	private final String branchId;
+	private final String loanOfficerId;
+	private final String centerId;
+	private final String meetingDate;
+
+	public CollectionSheetReportParameters(String branchId,
+			String loanOfficerId, String centerId, String meetingDate) {
+		this.branchId = branchId;
+		this.loanOfficerId = loanOfficerId;
+		this.centerId = centerId;
+		this.meetingDate = meetingDate;
+	}
+
+	public void validate(Errors errors) {
+		addErrorIfInvalid(errors, branchId,
+				SELECT_BRANCH_OFFICE_SELECTION_ITEM
+						.getId(), BRANCH_ID_PARAM, "branchId.invalid");
+		addErrorIfInvalid(errors, loanOfficerId,
+				SELECT_LOAN_OFFICER_SELECTION_ITEM
+						.getId(), LOAN_OFFICER_ID_PARAM,
+				LOAN_OFFICER_ID_INVALID_MSG);
+		addErrorIfInvalid(errors, loanOfficerId,
+				NA_LOAN_OFFICER_SELECTION_ITEM
+						.getId(), LOAN_OFFICER_ID_PARAM,
+				LOAN_OFFICER_ID_INVALID_MSG);
+		addErrorIfInvalid(errors, centerId,
+				SELECT_CENTER_SELECTION_ITEM.getId(),
+				CENTER_ID_PARAM, CENTER_ID_INVALID_MSG);
+		addErrorIfInvalid(errors, centerId,
+				NA_CENTER_SELECTION_ITEM.getId(),
+				CENTER_ID_PARAM, CENTER_ID_INVALID_MSG);
+		addErrorIfInvalid(errors, meetingDate,
+				DateSelectionItem.NA_MEETING_DATE.getDate(),
+				MEETING_DATE_PARAM, MEETING_DATE_INVALID_MSG);
+	}
+
+	private void addErrorIfInvalid(Errors errors, String parameter,
+			Date notAvailableDate, String fieldName, String errorCode) {
+		Date date = null;
+		try {
+			date = REPORT_DATE_PARAM_FORMAT.parse(parameter);
+		}
+		catch (ParseException e) {
+		}
+		if (notAvailableDate.equals(date)) {
+			errors.rejectValue(fieldName, errorCode);
+		}
+	}
+
+	private void addErrorIfInvalid(Errors errors, String parameter,
+			Integer selectValue, String fieldName, String errorCode) {
+		if (!NumberUtils.isDigits(parameter)
+				|| selectValue.equals(Integer.valueOf(parameter))) {
+			errors.rejectValue(fieldName, errorCode);
+		}
+	}
+
+	private void addErrorIfInvalid(Errors errors, String parameter,
+			Short selectValue, String fieldName, String errorCode) {
+		if (!NumberUtils.isDigits(parameter)
+				|| selectValue.equals(Short.valueOf(parameter))) {
+			errors.rejectValue(fieldName, errorCode);
+		}
+	}
+
+	public static CollectionSheetReportParameters build(
+			HttpServletRequest request) {
+		return new CollectionSheetReportParameters(extractBranchId(request),
+				extractLoanOfficerId(request), extractCenterId(request),
+				extractMeetingDate(request));
+	}
+
+	private static String getParameter(HttpServletRequest request,
+			String paramName) {
+		String parameter = request.getParameter(paramName);
+		return parameter != null ? parameter : request.getAttribute(parameter)
+				.toString();
+	}
+
+	public void removeRequestParameters(
+			ModifiableParameterServletRequest modifiedRequest, Errors errors) {
+		for (String reportParam : REPORT_PARAMS_ARRAY) {
+			if (errors.getFieldError(reportParam) != null)
+				modifiedRequest.removeParameter(reportParam);
+		}
+	}
+
+	private static String extractMeetingDate(HttpServletRequest request) {
+		return getParameter(request, MEETING_DATE_PARAM);
+	}
+
+	private static String extractCenterId(HttpServletRequest request) {
+		return getParameter(request, CENTER_ID_PARAM);
+	}
+
+	private static String extractLoanOfficerId(HttpServletRequest request) {
+		return getParameter(request, LOAN_OFFICER_ID_PARAM);
+	}
+
+	private static String extractBranchId(HttpServletRequest request) {
+		return getParameter(request, BRANCH_ID_PARAM);
+	}
+}
Index: src/org/mifos/application/reports/business/validator/DetailedAgingPortfolioReportParamValidator.java
===================================================================
--- src/org/mifos/application/reports/business/validator/DetailedAgingPortfolioReportParamValidator.java	(revision 0)
+++ src/org/mifos/application/reports/business/validator/DetailedAgingPortfolioReportParamValidator.java	(revision 0)
@@ -0,0 +1,25 @@
+package org.mifos.application.reports.business.validator;
+
+import javax.servlet.http.HttpServletRequest;
+
+import org.mifos.application.reports.business.DetailedAgingPortfolioReportParameters;
+import org.mifos.application.reports.business.ReportParameterForm;
+import org.mifos.framework.servlet.ModifiableParameterServletRequest;
+
+public class DetailedAgingPortfolioReportParamValidator  implements
+		ReportParameterValidator<DetailedAgingPortfolioReportParameters> {
+
+	public static final ReportParameterValidator INSTANCE = new DetailedAgingPortfolioReportParamValidator();
+	
+	public DetailedAgingPortfolioReportParameters buildReportParameterForm(HttpServletRequest request) {
+		return DetailedAgingPortfolioReportParameters.build(request);
+	}
+
+	public void removeRequestParameters(ModifiableParameterServletRequest modifiedRequest, ReportParameterForm form, Errors errors) {
+		form.removeRequestParameters(modifiedRequest, errors);
+	}
+
+	public void validate(DetailedAgingPortfolioReportParameters target, Errors errors) {
+		target.validate(errors);
+	}
+}
Index: src/org/mifos/application/reports/business/validator/ReportParameterValidator.java
===================================================================
--- src/org/mifos/application/reports/business/validator/ReportParameterValidator.java	(revision 0)
+++ src/org/mifos/application/reports/business/validator/ReportParameterValidator.java	(revision 0)
@@ -0,0 +1,12 @@
+package org.mifos.application.reports.business.validator;
+
+import javax.servlet.http.HttpServletRequest;
+
+import org.mifos.application.reports.business.ReportParameterForm;
+import org.mifos.framework.servlet.ModifiableParameterServletRequest;
+
+public interface ReportParameterValidator<T extends ReportParameterForm> {
+	public void validate(T target, Errors errors);
+	public T buildReportParameterForm(HttpServletRequest request);
+	public void removeRequestParameters(ModifiableParameterServletRequest modifiedRequest, ReportParameterForm form, Errors errors);
+}
Index: src/org/mifos/application/reports/business/validator/CollectionSheetReportParamValidator.java
===================================================================
--- src/org/mifos/application/reports/business/validator/CollectionSheetReportParamValidator.java	(revision 0)
+++ src/org/mifos/application/reports/business/validator/CollectionSheetReportParamValidator.java	(revision 0)
@@ -0,0 +1,26 @@
+package org.mifos.application.reports.business.validator;
+
+import javax.servlet.http.HttpServletRequest;
+
+import org.mifos.application.reports.business.CollectionSheetReportParameters;
+import org.mifos.application.reports.business.ReportParameterForm;
+import org.mifos.framework.servlet.ModifiableParameterServletRequest;
+
+
+public class CollectionSheetReportParamValidator implements
+		ReportParameterValidator<CollectionSheetReportParameters> {
+	public static final ReportParameterValidator INSTANCE = new CollectionSheetReportParamValidator();
+
+	public void validate(CollectionSheetReportParameters target, Errors errors) {
+		target.validate(errors);
+	}
+
+	public CollectionSheetReportParameters buildReportParameterForm(
+			HttpServletRequest request) {
+		return CollectionSheetReportParameters.build(request);
+	}
+
+	public void removeRequestParameters(ModifiableParameterServletRequest modifiedRequest, ReportParameterForm form, Errors errors) {
+		form.removeRequestParameters(modifiedRequest, errors);
+	}
+}
Index: src/org/mifos/application/reports/business/validator/Errors.java
===================================================================
--- src/org/mifos/application/reports/business/validator/Errors.java	(revision 0)
+++ src/org/mifos/application/reports/business/validator/Errors.java	(revision 0)
@@ -0,0 +1,58 @@
+package org.mifos.application.reports.business.validator;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Locale;
+
+import org.mifos.application.master.MessageLookup;
+
+public class Errors {
+	List<ErrorEntry> errors;
+	private final Locale locale;
+
+	public Errors(Locale locale) {
+		this.locale = locale;
+		errors = new ArrayList<ErrorEntry>();
+	}
+
+	public void rejectValue(String fieldName, String errorCode) {
+		errors.add(new ErrorEntry(fieldName, errorCode));
+	}
+
+	public List<String> getAllErrorMessages() {
+		List<String> errorMessages = new ArrayList<String>();
+		for (ErrorEntry entry : errors) {
+			errorMessages.add(MessageLookup.getInstance().lookup(
+					entry.errorCode, locale));
+
+		}
+		return errorMessages;
+	}
+
+	public boolean hasErrors() {
+		return !errors.isEmpty();
+	}
+
+	public List<ErrorEntry> getErrors() {
+		return errors;
+	}
+
+	public static class ErrorEntry {
+		final String fieldName;
+		final String errorCode;
+
+		public ErrorEntry(String fieldName, String errorCode) {
+			super();
+			this.fieldName = fieldName;
+			this.errorCode = errorCode;
+		}
+	}
+
+	public ErrorEntry getFieldError(String fieldName) {
+		for (ErrorEntry errorEntry : errors) {
+			if(errorEntry.fieldName.equals(fieldName))
+				return errorEntry;
+		}
+		return null;
+	}
+}
Index: src/org/mifos/application/reports/business/dto/LoanProductDetails.java
===================================================================
--- src/org/mifos/application/reports/business/dto/LoanProductDetails.java	(revision 0)
+++ src/org/mifos/application/reports/business/dto/LoanProductDetails.java	(revision 0)
@@ -0,0 +1,56 @@
+package org.mifos.application.reports.business.dto;
+
+import org.mifos.application.collectionsheet.business.CollSheetLnDetailsEntity;
+import org.mifos.framework.util.helpers.MoneyUtils;
+
+public class LoanProductDetails {
+	private final Double balance;
+	private final Double due;
+	private final Double otherFee;
+	private final Double otherFine;
+	private final Double issues;
+	private final String offeringShortName;
+
+	public LoanProductDetails(CollSheetLnDetailsEntity loanDetails,
+			String offeringShortName) {
+		this.offeringShortName = offeringShortName;
+		if (loanDetails == null) {
+			balance = due = issues = otherFee = otherFine = 0d;
+		}
+		else {
+			balance = MoneyUtils.getMoneyDoubleValue(loanDetails
+					.getTotalPrincipalDue());
+			due = MoneyUtils.getMoneyDoubleValue(loanDetails.getTotalAmntDue());
+			issues = MoneyUtils.getMoneyDoubleValue(loanDetails
+					.getAmntToBeDisbursed());
+			otherFee = MoneyUtils.getMoneyDoubleValue(loanDetails
+					.getTotalFees());
+			otherFine = MoneyUtils.getMoneyDoubleValue(loanDetails
+					.getTotalPenalty());
+		}
+	}
+
+	public Double getBalance() {
+		return balance;
+	}
+
+	public Double getDue() {
+		return due;
+	}
+
+	public Double getIssues() {
+		return issues;
+	}
+
+	Double getOtherFee() {
+		return otherFee;
+	}
+
+	Double getOtherFine() {
+		return otherFine;
+	}
+
+	public String getOfferingShortName() {
+		return offeringShortName;
+	}
+}
Index: src/org/mifos/application/reports/business/dto/SavingsProductDetails.java
===================================================================
--- src/org/mifos/application/reports/business/dto/SavingsProductDetails.java	(revision 0)
+++ src/org/mifos/application/reports/business/dto/SavingsProductDetails.java	(revision 0)
@@ -0,0 +1,37 @@
+package org.mifos.application.reports.business.dto;
+
+import org.mifos.application.collectionsheet.business.CollSheetSavingsDetailsEntity;
+import org.mifos.framework.util.helpers.MoneyUtils;
+
+public class SavingsProductDetails {
+
+	private final Double balance;
+	private final Double due;
+	private final String offeringShortName;
+
+	public SavingsProductDetails(CollSheetSavingsDetailsEntity savingsDetails,
+			String offeringShortName) {
+		this.offeringShortName = offeringShortName;
+		if (savingsDetails != null) {
+			balance = MoneyUtils.getMoneyDoubleValue(savingsDetails
+					.getAccountBalance());
+			due = MoneyUtils.getMoneyDoubleValue(savingsDetails
+					.getRecommendedAmntDue());
+		}
+		else {
+			balance = due = 0d;
+		}
+	}
+
+	public Double getBalance() {
+		return balance;
+	}
+
+	public Double getDue() {
+		return due;
+	}
+
+	public String getOfferingShortName() {
+		return offeringShortName;
+	}
+}
Index: src/org/mifos/application/reports/business/dto/CollectionSheetReportDTO.java
===================================================================
--- src/org/mifos/application/reports/business/dto/CollectionSheetReportDTO.java	(revision 0)
+++ src/org/mifos/application/reports/business/dto/CollectionSheetReportDTO.java	(revision 0)
@@ -0,0 +1,105 @@
+package org.mifos.application.reports.business.dto;
+
+import org.mifos.application.collectionsheet.business.CollSheetLnDetailsEntity;
+import org.mifos.application.collectionsheet.business.CollSheetSavingsDetailsEntity;
+import org.mifos.application.customer.business.CustomerBO;
+import org.mifos.framework.util.helpers.NumberUtils;
+
+// Understands collection sheet report properties
+public class CollectionSheetReportDTO {
+	private final Integer customerId;
+	private final Integer groupId;
+	private final Integer centerId;
+	private final Integer loanOfficerId;
+	private final String customerName;
+	private final String branchName;
+	private final String centerName;
+	private final String groupName;
+	private final String loanOfficerName;
+	private final LoanProductDetails[] loanProducts;
+	private SavingsProductDetails[] savingsProducts;
+
+	public CollectionSheetReportDTO(
+			CollSheetLnDetailsEntity loanDetailsEntity1,
+			CollSheetLnDetailsEntity loanDetailsEntity2,
+			CollSheetSavingsDetailsEntity mm1SavingsDetailEntity,
+			CollSheetSavingsDetailsEntity mm2SavingsDetailEntity,
+			Integer customerId, Integer groupId, String customerName,
+			String branchName, String groupName, CustomerBO center,
+			String loanOfferingShortName1, String loanOfferingShortName2,
+			String savingsOfferingShortName1, String savingsOfferingShortName2) {
+
+		loanProducts = new LoanProductDetails[2];
+		loanProducts[0] = new LoanProductDetails(loanDetailsEntity1, loanOfferingShortName1);
+		loanProducts[1] = new LoanProductDetails(loanDetailsEntity2, loanOfferingShortName2);
+
+		this.customerId = customerId;
+		this.groupId = groupId;
+		this.loanOfficerId = NumberUtils.convertShortToInteger(center
+				.getPersonnel().getPersonnelId());
+		this.loanOfficerName = center.getPersonnel().getDisplayName();
+		this.customerName = customerName;
+		centerId = center.getCustomerId();
+		centerName = center.getDisplayName();
+		this.branchName = branchName;
+		this.groupName = groupName;
+
+		savingsProducts = new SavingsProductDetails[2];
+		savingsProducts[0] = new SavingsProductDetails(mm1SavingsDetailEntity, savingsOfferingShortName1);
+		savingsProducts[1] = new SavingsProductDetails(mm2SavingsDetailEntity, savingsOfferingShortName2);
+	}
+
+	public SavingsProductDetails getSavingsProduct(int index) {
+		return savingsProducts[index];
+	}
+
+	public LoanProductDetails getLoanProduct(int index) {
+		return loanProducts[index];
+	}
+
+
+	public String getBranchName() {
+		return branchName;
+	}
+
+	public Integer getCenterId() {
+		return centerId;
+	}
+
+	public String getCenterName() {
+		return centerName;
+	}
+
+	public Integer getCustomerId() {
+		return customerId;
+	}
+
+	public String getCustomerName() {
+		return customerName;
+	}
+
+	public Integer getGroupId() {
+		return groupId;
+	}
+
+	public String getGroupName() {
+		return groupName;
+	}
+
+	public Integer getLoanOfficerId() {
+		return loanOfficerId;
+	}
+
+	public String getLoanOfficerName() {
+		return loanOfficerName;
+	}
+
+	public Double getOtherFee() {
+		return loanProducts[0].getOtherFee() + loanProducts[1].getOtherFee();
+	}
+
+	public Double getOtherFine() {
+		return loanProducts[0].getOtherFine() + loanProducts[1].getOtherFine();
+	}
+
+}
Index: src/org/mifos/application/reports/business/service/ReportsParameterService.java
===================================================================
--- src/org/mifos/application/reports/business/service/ReportsParameterService.java	(revision 0)
+++ src/org/mifos/application/reports/business/service/ReportsParameterService.java	(revision 0)
@@ -0,0 +1,61 @@
+package org.mifos.application.reports.business.service;
+
+import java.util.Date;
+import java.util.List;
+
+import org.mifos.application.customer.util.helpers.CustomerLevel;
+import org.mifos.application.reports.persistence.DateSelectionItemPersistence;
+import org.mifos.application.reports.persistence.SelectionItemPersistence;
+import org.mifos.application.reports.ui.DateSelectionItem;
+import org.mifos.application.reports.ui.SelectionItem;
+import org.mifos.framework.exceptions.PersistenceException;
+
+public class ReportsParameterService implements IReportsParameterService {
+
+	private SelectionItemPersistence selectionItemPersistence;
+	private DateSelectionItemPersistence dateSelectionItemPersistence;
+
+	public ReportsParameterService(
+			SelectionItemPersistence selectionItemPersistence,
+			DateSelectionItemPersistence dateSelectionItemPersistence) {
+		super();
+		this.selectionItemPersistence = selectionItemPersistence;
+		this.dateSelectionItemPersistence = dateSelectionItemPersistence;
+	}
+
+	public ReportsParameterService() {
+		selectionItemPersistence = new SelectionItemPersistence();
+		dateSelectionItemPersistence = new DateSelectionItemPersistence();
+	}
+
+	public List<SelectionItem> getActiveBranchesUnderUser(String officeSearchId)
+			throws PersistenceException {
+		return selectionItemPersistence
+				.getActiveBranchesUnderUser(officeSearchId);
+	}
+
+	public List<SelectionItem> getActiveLoanOfficersUnderOffice(Short branchId)
+			throws PersistenceException {
+		return selectionItemPersistence
+				.getActiveLoanOfficersUnderOffice(branchId);
+	}
+
+	public List<SelectionItem> getActiveCentersUnderUser(Short branchId,
+			Short loanOfficerId) throws PersistenceException {
+		return selectionItemPersistence.getActiveCentersUnderUser(branchId,
+				loanOfficerId);
+	}
+
+	public List<DateSelectionItem> getMeetingDates(Short branchId,
+			Short loanOfficerId, Integer centerId, CustomerLevel customerLevel,
+			Date from) throws PersistenceException {
+		return dateSelectionItemPersistence.getMeetingDates(branchId,
+				loanOfficerId, centerId, customerLevel.getValue(), from);
+	}
+
+	public List<SelectionItem> getActiveGroupsUnderUser(Short branchId,
+			Short loanOfficerId) throws PersistenceException {
+		return selectionItemPersistence.getActiveGroupsUnderUser(branchId,
+				loanOfficerId);
+	}
+}
